From 8485fc23d54cc1e359a71801845ea255584905d5 Mon Sep 17 00:00:00 2001
From: Robert Haas <rhaas@postgresql.org>
Date: Wed, 14 Jun 2023 11:31:29 -0400
Subject: [PATCH v1 7/8] Prototype patch for incremental and differential
 backup.

We don't differentiate between incremental and differential backups;
the term "incremental" as used herein means "either incremental or
differential".

This adds a new background process, the WAL summarizer, whose behavor
is governed by new GUCs wal_summarize_mb and wal_summarize_keep_time.
This writes out WAL summary files to $PGDATA/pg_wal/summaries. Each
summary file contains information for a certain range of LSNs on a
certain TLI. For each relation, it stores a "limit block" which is
0 if a relation is created or destroyed within a certain range of WAL
records, or otherwise the shortest length to which the relation was
truncated during that range of WAL records, or otherwise
InvalidBlockNumber. In addition, it stores any blocks which have
been modified during that range of WAL records, but excluding blocks
which were removed by truncation after they were modified and which
were never modified thereafter. In other words, it tells us which
blocks need to copied in case of an incremental backup covering that
range of WAL records.

To take an incremental backup, you use the new replication command
UPLOAD_MANIFEST to upload the manifest for the prior backup. This
prior backup could either be a full backup or another incremental
backup.  You then use BASE_BACKUP with the INCREMENTAL option to take
the backup.  pg_basebackup now has an --incremental=PATH_TO_MANIFEST
option to trigger this behavior.

An incremental backup is like a regular full backup except that
some relation files are replaced with files with names like
INCREMENTAL.${ORIGINAL_NAME}, and the backup_label file contains
additional lines identifying it as an incremental backup. The new
pg_combinebackup tool can be used to reconstruct a data directory
from a full backup and a series of incremental backups.

XXX. It would be nice if we could do something about incremental
JSON parsing.

XXX. This needs a lot of work on documentation and tests.

Patch by me. Thanks to Dilip Kumar and Andres Freund for some helpful
design discussions.
---
 doc/src/sgml/monitoring.sgml                  |   17 +
 src/backend/access/transam/xlog.c             |   97 +-
 src/backend/access/transam/xlogbackup.c       |   10 +
 src/backend/access/transam/xlogrecovery.c     |   10 +-
 src/backend/backup/Makefile                   |    5 +-
 src/backend/backup/basebackup.c               |  340 +++-
 src/backend/backup/basebackup_incremental.c   |  867 ++++++++++
 src/backend/backup/meson.build                |    3 +
 src/backend/backup/walsummary.c               |  356 +++++
 src/backend/backup/walsummaryfuncs.c          |  169 ++
 src/backend/postmaster/Makefile               |    1 +
 src/backend/postmaster/auxprocess.c           |    8 +
 src/backend/postmaster/meson.build            |    1 +
 src/backend/postmaster/postmaster.c           |   53 +
 src/backend/postmaster/walsummarizer.c        | 1414 +++++++++++++++++
 src/backend/replication/repl_gram.y           |   14 +-
 src/backend/replication/repl_scanner.l        |    2 +
 src/backend/replication/walsender.c           |  162 +-
 src/backend/storage/ipc/ipci.c                |    3 +
 src/backend/storage/lmgr/lwlocknames.txt      |    1 +
 src/backend/utils/activity/pgstat_io.c        |    4 +-
 src/backend/utils/activity/wait_event.c       |   15 +
 src/backend/utils/init/miscinit.c             |    3 +
 src/backend/utils/misc/guc_tables.c           |   29 +
 src/backend/utils/misc/postgresql.conf.sample |    5 +
 src/bin/Makefile                              |    1 +
 src/bin/initdb/initdb.c                       |    1 +
 src/bin/meson.build                           |    1 +
 src/bin/pg_basebackup/bbstreamer_file.c       |    1 +
 src/bin/pg_basebackup/pg_basebackup.c         |  108 +-
 src/bin/pg_basebackup/t/010_pg_basebackup.pl  |    4 +-
 src/bin/pg_combinebackup/.gitignore           |    1 +
 src/bin/pg_combinebackup/Makefile             |   46 +
 src/bin/pg_combinebackup/backup_label.c       |  281 ++++
 src/bin/pg_combinebackup/backup_label.h       |   29 +
 src/bin/pg_combinebackup/copy_file.c          |  169 ++
 src/bin/pg_combinebackup/copy_file.h          |   19 +
 src/bin/pg_combinebackup/load_manifest.c      |  245 +++
 src/bin/pg_combinebackup/load_manifest.h      |   67 +
 src/bin/pg_combinebackup/meson.build          |   29 +
 src/bin/pg_combinebackup/pg_combinebackup.c   | 1268 +++++++++++++++
 src/bin/pg_combinebackup/reconstruct.c        |  618 +++++++
 src/bin/pg_combinebackup/reconstruct.h        |   32 +
 src/bin/pg_combinebackup/write_manifest.c     |  293 ++++
 src/bin/pg_combinebackup/write_manifest.h     |   33 +
 src/bin/pg_resetwal/pg_resetwal.c             |   36 +
 src/common/Makefile                           |    1 +
 src/common/blkreftable.c                      | 1309 +++++++++++++++
 src/common/meson.build                        |    1 +
 src/include/access/xlog.h                     |    1 +
 src/include/access/xlogbackup.h               |    2 +
 src/include/backup/basebackup.h               |    5 +-
 src/include/backup/basebackup_incremental.h   |   56 +
 src/include/backup/walsummary.h               |   49 +
 src/include/catalog/pg_proc.dat               |   19 +
 src/include/common/blkreftable.h              |  120 ++
 src/include/miscadmin.h                       |    3 +
 src/include/nodes/replnodes.h                 |    9 +
 src/include/postmaster/walsummarizer.h        |   31 +
 src/include/storage/proc.h                    |    9 +-
 src/include/utils/guc_tables.h                |    1 +
 src/include/utils/wait_event.h                |    7 +-
 src/test/recovery/t/001_stream_rep.pl         |    2 +
 src/test/recovery/t/019_replslot_limit.pl     |    3 +
 .../t/035_standby_logical_decoding.pl         |    1 +
 src/tools/pgindent/typedefs.list              |   24 +
 66 files changed, 8454 insertions(+), 70 deletions(-)
 create mode 100644 src/backend/backup/basebackup_incremental.c
 create mode 100644 src/backend/backup/walsummary.c
 create mode 100644 src/backend/backup/walsummaryfuncs.c
 create mode 100644 src/backend/postmaster/walsummarizer.c
 create mode 100644 src/bin/pg_combinebackup/.gitignore
 create mode 100644 src/bin/pg_combinebackup/Makefile
 create mode 100644 src/bin/pg_combinebackup/backup_label.c
 create mode 100644 src/bin/pg_combinebackup/backup_label.h
 create mode 100644 src/bin/pg_combinebackup/copy_file.c
 create mode 100644 src/bin/pg_combinebackup/copy_file.h
 create mode 100644 src/bin/pg_combinebackup/load_manifest.c
 create mode 100644 src/bin/pg_combinebackup/load_manifest.h
 create mode 100644 src/bin/pg_combinebackup/meson.build
 create mode 100644 src/bin/pg_combinebackup/pg_combinebackup.c
 create mode 100644 src/bin/pg_combinebackup/reconstruct.c
 create mode 100644 src/bin/pg_combinebackup/reconstruct.h
 create mode 100644 src/bin/pg_combinebackup/write_manifest.c
 create mode 100644 src/bin/pg_combinebackup/write_manifest.h
 create mode 100644 src/common/blkreftable.c
 create mode 100644 src/include/backup/basebackup_incremental.h
 create mode 100644 src/include/backup/walsummary.h
 create mode 100644 src/include/common/blkreftable.h
 create mode 100644 src/include/postmaster/walsummarizer.h

diff --git a/doc/src/sgml/monitoring.sgml b/doc/src/sgml/monitoring.sgml
index 5cfdc70c03..97809a73f6 100644
--- a/doc/src/sgml/monitoring.sgml
+++ b/doc/src/sgml/monitoring.sgml
@@ -1161,6 +1161,10 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
       <entry><literal>WalSenderMain</literal></entry>
       <entry>Waiting in main loop of WAL sender process.</entry>
      </row>
+     <row>
+      <entry><literal>WalSummarizeWAL</literal></entry>
+      <entry>Waiting in WAL summarizer process for new WAL to be written.</entry>
+     </row>
      <row>
       <entry><literal>WalWriterMain</literal></entry>
       <entry>Waiting in main loop of WAL writer process.</entry>
@@ -1591,6 +1595,14 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
       <entry>Waiting for a read from a timeline history file during a walsender
        timeline command.</entry>
      </row>
+     <row>
+      <entry><literal>WalSummaryRead</literal></entry>
+      <entry>Waiting to read from a WAL summary file.</entry>
+     </row>
+     <row>
+      <entry><literal>WalSummaryWrite</literal></entry>
+      <entry>Waiting to write to a WAL summary file.</entry>
+     </row>
      <row>
       <entry><literal>WALSync</literal></entry>
       <entry>Waiting for a WAL file to reach durable storage.</entry>
@@ -2357,6 +2369,11 @@ postgres   27093  0.0  0.0  30096  2752 ?        Ss   11:34   0:00 postgres: ser
       <entry>Waiting to acquire an exclusive lock to truncate off any
        empty pages at the end of a table vacuumed.</entry>
      </row>
+     <row>
+      <entry><literal>WalSummarizerError</literal></entry>
+      <entry>Waiting to retry after recovering from an error in the
+       WAL summarizer process.</entry>
+     </row>
     </tbody>
    </tgroup>
   </table>
diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 664d4ba598..6c66d5118b 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -77,6 +77,7 @@
 #include "port/pg_iovec.h"
 #include "postmaster/bgwriter.h"
 #include "postmaster/startup.h"
+#include "postmaster/walsummarizer.h"
 #include "postmaster/walwriter.h"
 #include "replication/logical.h"
 #include "replication/origin.h"
@@ -3477,6 +3478,43 @@ XLogGetLastRemovedSegno(void)
 	return lastRemovedSegNo;
 }
 
+/*
+ * Return the oldest WAL segment on the given TLI that still exists in
+ * XLOGDIR, or 0 if none.
+ */
+XLogSegNo
+XLogGetOldestSegno(TimeLineID tli)
+{
+	DIR		   *xldir;
+	struct dirent *xlde;
+	XLogSegNo	oldest_segno = 0;
+
+	xldir = AllocateDir(XLOGDIR);
+	while ((xlde = ReadDir(xldir, XLOGDIR)) != NULL)
+	{
+		TimeLineID	file_tli;
+		XLogSegNo	file_segno;
+
+		/* Ignore files that are not XLOG segments */
+		if (!IsXLogFileName(xlde->d_name))
+			continue;
+
+		/* Parse filename to get TLI and segno. */
+		XLogFromFileName(xlde->d_name, &file_tli, &file_segno,
+						 wal_segment_size);
+
+		/* Ignore anything that's not from the TLI of interest. */
+		if (tli != file_tli)
+			continue;
+
+		/* If it's the oldest so far, update oldest_segno. */
+		if (oldest_segno == 0 || file_segno < oldest_segno)
+			oldest_segno = file_segno;
+	}
+
+	FreeDir(xldir);
+	return oldest_segno;
+}
 
 /*
  * Update the last removed segno pointer in shared memory, to reflect that the
@@ -3756,8 +3794,8 @@ RemoveXlogFile(const struct dirent *segment_de,
 }
 
 /*
- * Verify whether pg_wal and pg_wal/archive_status exist.
- * If the latter does not exist, recreate it.
+ * Verify whether pg_wal, pg_wal/archive_status, and pg_wal/summaries exist.
+ * If the latter do not exist, recreate them.
  *
  * It is not the goal of this function to verify the contents of these
  * directories, but to help in cases where someone has performed a cluster
@@ -3800,6 +3838,26 @@ ValidateXLOGDirectoryStructure(void)
 					(errmsg("could not create missing directory \"%s\": %m",
 							path)));
 	}
+
+	/* Check for summaries */
+	snprintf(path, MAXPGPATH, XLOGDIR "/summaries");
+	if (stat(path, &stat_buf) == 0)
+	{
+		/* Check for weird cases where it exists but isn't a directory */
+		if (!S_ISDIR(stat_buf.st_mode))
+			ereport(FATAL,
+					(errmsg("required WAL directory \"%s\" does not exist",
+							path)));
+	}
+	else
+	{
+		ereport(LOG,
+				(errmsg("creating missing WAL directory \"%s\"", path)));
+		if (MakePGDirectory(path) < 0)
+			ereport(FATAL,
+					(errmsg("could not create missing directory \"%s\": %m",
+							path)));
+	}
 }
 
 /*
@@ -5123,9 +5181,9 @@ StartupXLOG(void)
 #endif
 
 	/*
-	 * Verify that pg_wal and pg_wal/archive_status exist.  In cases where
-	 * someone has performed a copy for PITR, these directories may have been
-	 * excluded and need to be re-created.
+	 * Verify that pg_wal, pg_wal/archive_status, and pg_wal/summaries exist.
+	 * In cases where someone has performed a copy for PITR, these directories
+	 * may have been excluded and need to be re-created.
 	 */
 	ValidateXLOGDirectoryStructure();
 
@@ -6802,6 +6860,17 @@ CreateCheckPoint(int flags)
 	 */
 	END_CRIT_SECTION();
 
+	/*
+	 * If there hasn't been much system activity in a while, the WAL
+	 * summarizer may be sleeping for relatively long periods, which could
+	 * delay an incremental backup that has started concurrently. In the hopes
+	 * of avoiding that, poke the WAL summarizer here.
+	 *
+	 * Possibly this should instead be done at some earlier point in this
+	 * function, but it's not clear that it matters much.
+	 */
+	SetWalSummarizerLatch();
+
 	/*
 	 * Let smgr do post-checkpoint cleanup (eg, deleting old files).
 	 */
@@ -7476,6 +7545,20 @@ KeepLogSeg(XLogRecPtr recptr, XLogSegNo *logSegNo)
 		}
 	}
 
+	/*
+	 * If WAL summarization is in use, don't remove WAL that has yet to be
+	 * summarized.
+	 */
+	keep = GetOldestUnsummarizedLSN(NULL, NULL);
+	if (keep != InvalidXLogRecPtr)
+	{
+		XLogSegNo	unsummarized_segno;
+
+		XLByteToSeg(keep, unsummarized_segno, wal_segment_size);
+		if (unsummarized_segno < segno)
+			segno = unsummarized_segno;
+	}
+
 	/* but, keep at least wal_keep_size if that's set */
 	if (wal_keep_size_mb > 0)
 	{
@@ -8462,8 +8545,8 @@ do_pg_backup_start(const char *backupidstr, bool fast, List **tablespaces,
 			/*
 			 * Try to parse the directory name as an unsigned integer.
 			 *
-			 * Tablespace directories should be positive integers that can
-			 * be represented in 32 bits, with no leading zeroes or trailing
+			 * Tablespace directories should be positive integers that can be
+			 * represented in 32 bits, with no leading zeroes or trailing
 			 * garbage. If we come across a name that doesn't meet those
 			 * criteria, skip it.
 			 */
diff --git a/src/backend/access/transam/xlogbackup.c b/src/backend/access/transam/xlogbackup.c
index 23461c9d2c..3ad6b679d5 100644
--- a/src/backend/access/transam/xlogbackup.c
+++ b/src/backend/access/transam/xlogbackup.c
@@ -77,6 +77,16 @@ build_backup_content(BackupState *state, bool ishistoryfile)
 		appendStringInfo(result, "STOP TIMELINE: %u\n", state->stoptli);
 	}
 
+	/* either both istartpoint and istarttli should be set, or neither */
+	Assert(XLogRecPtrIsInvalid(state->istartpoint) == (state->istarttli == 0));
+	if (!XLogRecPtrIsInvalid(state->istartpoint))
+	{
+		appendStringInfo(result, "INCREMENTAL FROM LSN: %X/%X\n",
+						 LSN_FORMAT_ARGS(state->istartpoint));
+		appendStringInfo(result, "INCREMENTAL FROM TLI: %u\n",
+						 state->istarttli);
+	}
+
 	data = result->data;
 	pfree(result);
 
diff --git a/src/backend/access/transam/xlogrecovery.c b/src/backend/access/transam/xlogrecovery.c
index 4ff4430006..89ddec5bf9 100644
--- a/src/backend/access/transam/xlogrecovery.c
+++ b/src/backend/access/transam/xlogrecovery.c
@@ -1284,6 +1284,12 @@ read_backup_label(XLogRecPtr *checkPointLoc, TimeLineID *backupLabelTLI,
 								 tli_from_file, BACKUP_LABEL_FILE)));
 	}
 
+	if (fscanf(lfp, "INCREMENTAL FROM LSN: %X/%X\n", &hi, &lo) > 0)
+		ereport(FATAL,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("this is an incremental backup, not a data directory"),
+				 errhint("Use pg_combinebackup to reconstruct a valid data directory.")));
+
 	if (ferror(lfp) || FreeFile(lfp))
 		ereport(FATAL,
 				(errcode_for_file_access(),
@@ -1340,7 +1346,7 @@ read_tablespace_map(List **tablespaces)
 	{
 		if (!was_backslash && (ch == '\n' || ch == '\r'))
 		{
-			char   *endp;
+			char	   *endp;
 
 			if (i == 0)
 				continue;		/* \r immediately followed by \n */
@@ -1363,7 +1369,7 @@ read_tablespace_map(List **tablespaces)
 			ti = palloc0(sizeof(tablespaceinfo));
 			errno = 0;
 			ti->oid = strtoul(str, &endp, 10);
-			if (*endp != '\0' ||  errno == EINVAL || errno == ERANGE)
+			if (*endp != '\0' || errno == EINVAL || errno == ERANGE)
 				ereport(FATAL,
 						(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 						 errmsg("invalid data in file \"%s\"", TABLESPACE_MAP)));
diff --git a/src/backend/backup/Makefile b/src/backend/backup/Makefile
index b21bd8ff43..751e6d3d5e 100644
--- a/src/backend/backup/Makefile
+++ b/src/backend/backup/Makefile
@@ -19,12 +19,15 @@ OBJS = \
 	basebackup.o \
 	basebackup_copy.o \
 	basebackup_gzip.o \
+	basebackup_incremental.o \
 	basebackup_lz4.o \
 	basebackup_zstd.o \
 	basebackup_progress.o \
 	basebackup_server.o \
 	basebackup_sink.o \
 	basebackup_target.o \
-	basebackup_throttle.o
+	basebackup_throttle.o \
+	walsummary.o \
+	walsummaryfuncs.o
 
 include $(top_srcdir)/src/backend/common.mk
